=== debian/changelog ===
cadabra2 (2.3.6.8-1ubuntu1) jammy; urgency=medium

  * Prevent CMake from selecting Python 3.9 over 3.10
  * Cherry-pick upstream commit for Python 3.10 compatibility

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 31 Jan 2022 18:02:11 +0000

cadabra2 (2.3.6.8-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 19:07:30 +0000

cadabra2 (2.3.6.8-1) unstable; urgency=medium

  * New upstream version. (Closes: #981534)
  * Bump standards version to 4.5.1.
  * d/copyright: drop unused copyright paragraph.
  * d/clean: added two more files.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 03 Feb 2021 15:45:42 +0100
